/* Note that this class uses some of the class library */

#include	"circbuf.cls"
#include	"assoc.h"
#include	"Dict.h"
#include	<string.h>
#include	"strng.h"
#include	<stdio.h>

_CLASSDEF(ConvListObj)

class _CLASSTYPE	ConvListObj:public Object {

public:
	int	count;
	char	*dest;

public:
	ConvListObj(const ConvListObj _FAR &o):count(o.count)
	{
		dest=new char[count+1];
		strcpy(dest,o.dest);
	}
	ConvListObj(const  int i,char * str):count(i)
	{
		dest=new char[i+1];
		strcpy(dest,str);
	}
	~ConvListObj(){ delete dest;}

	virtual classType 		isA() const { return __firstUserClass; }
	virtual char _FAR 		*nameOf() const { return "ConvListObj";}
	virtual hashValueType hashValue() const {
		return hashValueType(_rotl(count,1));
	}
	virtual int _FAR			isEqual(const Object _FAR &o) const {
		return count==((ConvListObj&)o).count;
	}
	virtual void	_FAR		print(ostream _FAR &out) const {
	};
	virtual	void	_FAR		printOn(ostream _FAR &out) const {
	};
};

_CLASSDEF(Filter)

class _CLASSTYPE Filter{
	CircularBuffer	Buffer;
	Dictionary			Dict;
	int							Cur_Ptr;
	int		store;	//This pair are used to store the values used in consume.
	int		istore;
	char	ch;			//
	BOOL	_Error;
public:
	Filter():Cur_Ptr(0),_Error(FALSE),store(0),istore(0)
	{
		Buffer.Size(128);
	}
	~Filter(){;};
	void	Consume(const char _FAR c);
	char	_FAR	Produce();
	void	AddConversion(char _FAR c,char _FAR *alt);
//	void	DelConversion(char c);
	int	_FAR	LookUp(char _FAR c);
	char	Get(char _FAR c,int _FAR &i);
	BOOL	_FAR	Error(){return _Error;}
	BOOL	_FAR	Empty()
	{
		BOOL	B=Buffer.Empty();
		BOOL	A=(BOOL)(store);
		return(BOOL)((!A)&&B);
	}
};
inline	int	_FAR Filter::LookUp(char _FAR c)
{
	char	str[2];
	str[0]=c;
	str[1]=0x00;
	String *KeyChar=new String(str);
	if(!KeyChar){printf("Trouble with allocate 4\n");return 0;}
	Association& Definition = Dict.lookup(*KeyChar);
	if(Definition==NOOBJECT)
	{
		delete KeyChar;
		return -1;
	}
	else
	{
		delete KeyChar;
		return((ConvListObj&) ((Object &)Definition.value())).count;
	}
}
inline	char _FAR Filter::Get(char _FAR c,int _FAR &i)
{
	char	retval;
	char	str[2];
	str[0]=c;
	str[1]=0x00;
	String *KeyChar=new String(str);
	if(!KeyChar){printf("Trouble with allocate 5\n");return 0x00;}
	Association& Definition=Dict.lookup(*KeyChar);
	if(Definition==NOOBJECT)
	{
		retval=0x00;
	}
	else
	retval=((ConvListObj&)((Object&)Definition.value())).dest[i++];
	delete	KeyChar;
	return retval;
}

inline	char  _FAR Filter::Produce()
{
	char retval;
	if(!Buffer.Empty())
	{
		retval=	Buffer.Remove();
		if(store)
		{
			Buffer.Add(Get(ch,store));
			store++;
			if(store>=istore) store=0;
		}
		return retval;
	}
	else return 0x00;
}
