#ifndef	LINE_CLS
#define	LINE_CLS

#include	"userdefs.h"

class	Line{
private:
	BOOL	_Full;						//Flag for full line, true if end of line or max char
	int		MaxLength;				//Maximum number of characters in line
	int		CurrentLength;
	int		TabSpaces;				//Number of spaces to use for tab character
	char	*line;
	BOOL	_NotAdded;
	char	EOL;
	BOOL	Initialised;
	int		_Error;
public:
	Line(int tab,char eol,int leng);
	Line(int tab,char eol);
	Line();
	~Line(){ delete []line;};
	void	Add(const char c);
	char	* Content();
	void	SetTab(const int tab);
	void	SetEOL(const char c){ EOL=c;}
	void	SetWidth(int w=80);
	BOOL	Full(){return _Full;}
	BOOL	NotAdded(){return _NotAdded;}
	void	Flush();
	int		Error(){return _Error;}
};

inline	Line::Line():_Full(FALSE),MaxLength(80),CurrentLength(0),
														TabSpaces(2),EOL('\n'),_Error(0)
{
	if(!(line=new char[MaxLength+1]))
	{
		_Error=1;
		Initialised=FALSE;
	}
	else	Initialised=TRUE;
};
inline	Line::Line(int tab,char eol,int leng):_Full(FALSE),MaxLength(leng),
					CurrentLength(0),TabSpaces(tab),EOL(eol),_Error(0)
{
	if(!(line=new char[MaxLength+1]))
	{
		_Error=1;
		Initialised=FALSE;
	}
	else	Initialised=TRUE;
}
inline	Line::Line(int tab,char eol):_Full(FALSE),MaxLength(80),CurrentLength(0),
														TabSpaces(tab),EOL(eol),_Error(0)
{
	if(!(line=new char[MaxLength+1]))
	{
		_Error=1;
		Initialised=FALSE;
	}
	else	Initialised=TRUE;
}

inline	char *Line::Content()
{
	line[CurrentLength]=0x00;
	return line;
}

inline	void	Line::SetTab(const int tab)
{
	TabSpaces=tab;
}

inline	void  Line::Flush()
{
	CurrentLength=0;
	_Full=FALSE;
	_NotAdded=FALSE;
}

inline	void	Line::SetWidth(int w)
{
	MaxLength=w;
	delete line;
	if(!(line=new char[MaxLength+1]))
	{
		_Error=1;
		Initialised=FALSE;
	}
	else	Initialised=TRUE;
	CurrentLength=0;
	_Error=0;
}

#endif
