#include	<stdio.h>
#include	"fstream.h"
#include	"page.cls"

#define	HEADER_LINE	1

Page::Page():PageNumber(0),LineNumber(0),_LineWidth(80),
						TopMargin(3),BottomMargin(3),PageLength(66),
						_UseFF(TRUE),_FF(0x0C),_ERROR(FALSE),_Full(FALSE),EOL('\n'),
						_UseHeader(TRUE)
{
	lines=new Line[PageLength];
	for(int i=0;i<PageLength;i++)
	{
		lines[i].SetTab(2);
		lines[i].SetEOL(EOL);
		lines[i].SetWidth(_LineWidth);
	}
	time(&T);
}
Page::Page(int plen,int top,int bottom,int linewidth):PageNumber(0),
						LineNumber(0),_LineWidth(linewidth),
						TopMargin(top),BottomMargin(bottom),PageLength(plen),
						_UseFF(TRUE),_FF(0x0C),_ERROR(FALSE),_Full(FALSE),EOL('\n'),
						_UseHeader(TRUE)
{
	lines=new Line[PageLength];
	for(int i=0;i<PageLength;i++)
	{
		lines[i].SetTab(2);
		lines[i].SetEOL(EOL);
		lines[i].SetWidth(_LineWidth);
	}
	time(&T);
}
void	Page::Add(char c)
{
	char	print[]=" Printed on ";
	char	buffer[10];
	struct	tm	*time_now;
	time_now=localtime(&T);
	char str[80];

	if(_Full) {_ERROR=TRUE; return;}
	if(LineNumber<TopMargin)
	{
		if(TopMargin>HEADER_LINE)
		{
			int i;
			sprintf(buffer,"%4d ",PageNumber+1);
			for(i=0;buffer[i];i++) lines[0].Add(buffer[i]);
			for(i=0;File_Name[i]&&(!lines[0].Full());i++)
				lines[0].Add(File_Name[i]);
			for(i=0;print[i];i++) lines[0].Add(print[i]);
			strftime(str,50,"%a %d %B %Y at %H:%M",time_now);
			for(i=0;str[i]!='\n'&&(i<50)&&(!lines[0].Full());i++)
				lines[0].Add(str[i]);
			LineNumber=1;
		}
		for(;LineNumber<TopMargin;LineNumber++)
			lines[LineNumber].Add(EOL);
	}
	lines[LineNumber].Add(c);
	if(lines[LineNumber].Full())	LineNumber++;
	if(LineNumber==PageLength-BottomMargin)
	{
		for(;LineNumber<PageLength;LineNumber++)
			lines[LineNumber].Add(EOL);
		_Full=TRUE;
	}
}
void	Page::PrintIt()
{
	ofstream chan[2];
	chan[0].attach(1);	/*.open("stdout");*/
	chan[1].attach(4);	/*.open("stdprn");*/

	if(LineNumber>0)
	{
		for(int i=0;i<PageLength;i++)
			chan[1]<< lines[i].Content()<<"\n";
	}
	PageNumber++;
}
void	Page::Flush()
{
	for(int i=0;i<PageLength;i++)
		lines[i].Flush();
	_Full=FALSE;
	LineNumber=0;
}
void	Page::SetFileName(const char *name)
{
	int j,k,i=strlen(name);
	for(j=i-1;j>0&&name[j]!='\\';j--);
	while(name[j]=='\\') j++;
	for(k=0;name[j]&&j<=i;j++,k++) File_Name[k]=name[j];
	File_Name[k]='\0';
}

void	Page::SetPathName(const char *path)
{
	int	i,k=strlen(path);
	for(i=k;i>0&&path[i]!='\\';i--);
	if(i>0) i++;
	for(k=0;k<i;k++) Path_Name[k]=path[k];
	Path_Name[k]='\0';
}
int	Page::LineWidth(int width)
{
	if(width<30) width=30;
	if(width>132) width=132;
	_LineWidth=width;
	for(int i=0;i<PageLength;i++) lines[i].SetWidth(_LineWidth);
	return _LineWidth;
}
