/**************************************************************************
*  Dump to printer, tabs set to 2, 80 char per line                       *
*  Written by D.M. Bolt, Oct 1990.                                        *
*  Copyright D.M. Bolt, 1990,91,93                                        *
*  Uses parameters or asks for file name:                                 *
*   prin [[path]filename.ext] [length]                                    *
*   path is the dos drive and path of the text file                       *
*   filename.exe is the file name and extension of the                    *
*   text file, no default is assumed                                      *
*   length is the line length in characters                               *
*   prin                                                                  *
*   Input source drive, directory, filename and extent (upto 75 chars)... *
*  The prompting usage assumes an 80 character line.                      *
*  The programme uses a 2 character tab and 60 lines per                  *
*  page. The default line length is 80 characters.                        *
*  The default page length is 66 lines.                                   *
***************************************************************************/

/* This file written with tabs set to 2. */
/* Note that this file uses some of the class library */

#include	"circbuf.cls"
#include	<Assoc.h>
#include	<Dict.h>
#include	<strng.h>
#include	<ctype.h>
#include	"Filter.cls"
#include	"line.cls"
#include	"page.cls"

#include	<io.h>
#include	<fstream.h>
#include	<iostream.h>

void	get_name(char	*file_name)
{
	cout<<"Input Source drive, directory, filename and\n";
	cout<<"extent (upto 75 chars)\n....";
	cin.get(file_name,75);
//	cin>>setw(75)>>file_name;
}

int	main(int argc,char *argv[])
{
	//Create required objects.
	//Initialise filter with conversion list
	//Initialise line with end of line characters to detect.
	//Initialise line with tab expansion count
	char		ch;
	char	file_name[75];
	int		length=80;
	if(argc<2)
	{
		get_name(file_name);
	}
	else
	{
		strcpy(file_name,argv[1]);
		if (argc>=3)	length=atoi(argv[2]);
	}
	Page	p(66,4,5,length);

	Filter	box;
	box.AddConversion('\r',"");

	ifstream	in;

	in.unsetf(ios::skipws);

	for(int i=0;i<strlen(file_name);i++) file_name[i]=toupper(file_name[i]);
	in.open(file_name);

	if(!in)
	{
		cout<<"Cannot open file.\n";
		return(1);
	}
	p.SetFileName(file_name);
	p.SetPathName(file_name);
	BOOL	A,B;
	A=(BOOL)in.eof();
	B=box.Empty();
	do	// producer-consumer loop
	{
		if(!A && B)
		{
			in>>ch;
			box.Consume(ch);
		}
		ch=box.Produce();
		if(ch)
		{
			p.Add(ch);
			if(p.Full())
			{
				p.PrintIt();
				p.Flush();
			}
		}
		A=(BOOL)in.eof();
		B=box.Empty();
	}
	while(!(A && B) );
	p.PrintIt();	//Just dump any remaining stuff.
	in.close();
	return(0);
}
